Flood Fill

Easy

Animageis represented by a 2-D array of integers, each integer representing the pixel value of the image (from 0 to 65535).

Given a coordinate(sr, sc)representing the starting pixel (row and column) of the flood fill, and a pixel valuenewColor, "flood fill" the image.

To perform a "flood fill", consider the starting pixel, plus any pixels connected 4-directionally to the starting pixel of the same color as the starting pixel, plus any pixels connected 4-directionally to those pixels (also with the same color as the starting pixel), and so on. Replace the color of all of the aforementioned pixels with the newColor.

At the end, return the modified image.

Example 1:

Input:

image = [[1,1,1],[1,1,0],[1,0,1]]
sr = 1, sc = 1, newColor = 2

Output:
 [[2,2,2],[2,2,0],[2,0,1]]

Explanation:

From the center of the image (with position (sr, sc) = (1, 1)), all pixels connected 
by a path of the same color as the starting pixel are colored with the new color.
Note the bottom corner is not colored 2, because it is not 4-directionally connected
to the starting pixel.

-----------------------

[
 [1, 1, 1],
 [1, 1, 0],
 [1, 0, 1]
]

Note:

The length of image and image[0] will be in the range [1, 50].

The given starting pixel will satisfy 0 <= sr < image.length and 0 <= sc < image[0].length.

The value of each color in image[i][j] and newColor will be an integer in [0, 65535].

Solution

DFS - Approach (11 ms, faster than 31.48%)

Time complexity: O(m*n), where m*n is the number of pixels in the image. We might process every pixel.

Space complexity: O(m*n), the size of the implicit call stack when calling dfs.

因为可以用是否为旧颜色判断是否访问过该节点,因此可以不用额外visited[][]来判定是否访问过。

class Solution {
    int[][] dirs = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
    public int[][] floodFill(int[][] image, int sr, int sc, int newColor) {
        if (image[sr][sc] != newColor) {
            dfs(image, sr, sc, image[sr][sc], newColor);
        }

        return image;
    }

    private void dfs(int[][] image, int row, int col, int srcColor, int newColor) {
        int m = image.length;
        int n = image[0].length;

        image[row][col] = newColor;

        for (int[] dir: dirs) {
            int nr = row + dir[0];
            int nc = col + dir[1];
            if (nr >= 0 && nr < m && nc >= 0 && nc < n) {
                if (image[nr][nc] == srcColor) {
                    dfs(image, nr, nc, srcColor, newColor);
                }
            }
        }
    }
}

https://leetcode.com/problems/flood-fill/solution/

Last updated